;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.4 - GPL3 - Apr 2013
;
;-----------------------------------------------------------------------------------
;
; Include file for BareNumbersOS program development
;-----------------------------------------------------------------------------------

; colors
ct_white_on_dgrey equ 0x0066666600ffffff ; text
ct_black_on_white equ 0x00ffffff00000000 ; tile

ct_black_on_lgrey equ 0x00cccccc00000000 ; text (items)
ct_white_on_lgrey equ 0x00cccccc00ffffff ; ctrl
ct_white_on_black equ 0x0000000000ffffff ; input (items)

; type
;-not used-	equ 0
TILE		equ 1
CHECK 		equ 2
LABEL		equ 3	; always disable
ACTIVELABEL	equ 4	; tag=1 -> actived
ARRAYALABEL	equ 5	; tag=id actived label
INPUTSTRING	equ 6
BITMAP		equ 7
CUSTOMCONTROL   equ 8

; tile/control offset
TYPE	 	equ 0
FLAGS	 	equ 1
IDCHAR 		equ 2
FOCUS	 	equ 3
YPOS 		equ 4
XPOS 		equ 5
YSIZE	 	equ 6
XSIZE	 	equ 7
SELECTED 	equ 8
NITEMS	 	equ 16
NUMBER	 	equ 24
TAG 		equ 32
TEXT	 	equ 40
PTPOINTER 	equ 48
COUNT		equ 56
COLOR1		equ 64
COLOR2		equ 72
COLOR3		equ 80
MLIST		equ 88
VALUE		equ 96
FUNCTION	equ 104
DRAW		equ 112
ACTION		equ 120

; flags
VD		equ 0	; visible & disable
VE		equ 1	; visible & enable
HD		equ 2	; hidden & disable
TH		equ 3	; to hide

;------------------------------------------------------------------------


;------------------------------------------------------------------------
;				       TILE		  | CONTROL
;------------------------------------------------------------------------
;	type		db 0	;  0 : type (1)	  	  | type (2->)
;	flags		db 0	;  1 : flags		  | flags
;       idchar	 	db 0    ;  2 : char id		  | char id
;	focus		db 0	;  3 : 0=off 1=on	  | 0=off 1=on
;	ypos 		db 0    ;  4 : y position 	  | y position
;       xpos		db 0    ;  5 : x position 	  | x position
;	ysize		db 0	;  6 : y size		  | y size
;	xsize		db 0	;  7 : x size		  | x size
;
;	selected       	dq 0	;  8 : sel.page (max 99)  | selected item
;	nitems		dq 0	; 16 : n.of pages (max 99)| number of items
;	number		dq 0	; 24 : none		  | number of ...
;	tag		dq 0	; 32 : tag		  | tag
;	text		dq 0	; 40 : text string pointer| text string pointer
;	ptpointer 	dq 0	; 48 : page ctrls list p. | tile pointer
;	count		dq 0	; 56 : none	 	  | page where is the control
;	color1		dq 0	; 64 : color text	  | color text
;	color2		dq 0	; 72 : color tile	  | color control
;
;	color3		dq 0	; 80 : not used		  | color items
;	mlist		dq 0	; 88 : not used		  | mem or list pointer
;	value		dq 0	; 96 : not used		  | value pointer
;	function	dq 0	;104 : not used		  | function pointer
;
;	draw		dq 0	;112 : not used		  | draw pointer (only for customcontrols)
;	action		dq 0	;120 : not used		  | action pointer (only for customcontrols)

;-----------------------------------------------------
; Put here strings
;-----------------------------------------------------
	null: db 0
	tile1str: db 'Test', 0
	hello_message: db 'Hello, world!', 0
	alabel1str: db 'EXIT', 0

;-----------------------------------------------------
; Put here lists
;-----------------------------------------------------

;-----------------------------------------------------
; Put here values
;-----------------------------------------------------

;-----------------------------------------------------------
; Put here the lists of tiles, pages and controls (in order)
;-----------------------------------------------------------
align 16
tiles_list:
	tiles    	:  dq 1, tile_a

align 16
tile_a_pages:
	tile_a1_ctrls   :  dq 2, ctrl_a1a, ctrl_a1b

;-----------------------------------------------------------
; Put here the init values of tiles (in order)
; n.b. there must be at least one visible tile
;-----------------------------------------------------------
align 16
tiles_init_values:

	tile_a	:  	db TILE, VE, 'a', 1, 20, 64, 18, 30
			dq 1, 1, 0, 0, tile1str
			dq tile_a_pages, 0, ct_white_on_dgrey, ct_black_on_white

;--------------------------------------------------------------
; Put here the init values of controls (in order)
;--------------------------------------------------------------
align 16
ctrls_init_values:

	ctrl_a1a:	db LABEL, VE, 'a', 0, 29, 72, 1, 14
			dq 0, 0, 0, 0, hello_message
			dq tile_a, 1, ct_black_on_lgrey, ct_white_on_lgrey, 0
			dq 0, 0, 0

	ctrl_a1b:	db ACTIVELABEL, VE, 'b', 0, 36, 75, 1, 7
			dq 0, 0, 0, 0, alabel1str
			dq tile_a, 1, ct_black_on_lgrey, ct_white_on_lgrey, 0
			dq 0, 0, alabel1function

;--------------------------------------------------------------------------------------------



;--------------------------------------------------------------
; Init and Start User Interface Manager
;--------------------------------------------------------------
start_UI:
	mov rax, tiles_list
	mov rbx, tile_a_pages
	call [sys_init_UI]
ret


; =============================================================================
; EOF


