;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.4 - GPL3 - Apr 2013
;
;-----------------------------------------------------------------------------------
;
; Include file for BareNumbersOS program development
;-----------------------------------------------------------------------------------

sys_tab:
;debug
sys_debug_dump_reg		dq 0	; 001 - Dump the registers to the screen
sys_debug_dump_mem		dq 0	; 002 - Dump contents of memory to the screen. IN: RSI = Start of memory address to dump, RCX = number of bytes to dump
sys_debug_dump_rax		dq 0	; 003 - Dump the content of RAX (64-bit) to the screen
sys_debug_dump_eax		dq 0	; 004 - Dump the content of EAX (32-bit) to the screen
sys_debug_dump_ax		dq 0	; 005 - Dump the content of AX (16-bit) to the screen
sys_debug_dump_al		dq 0	; 006 - Dump the content of AL (8-bit) to the screen
;file
sys_fs_command_break		dq 0	; 007 - Break the contents of string into individual strings. IN: RSI = command arguments string. OUT: RSI = command arguments string (breaked), RCX = num. of words in the string
sys_fs_command			dq 0	; 008 - File system commands executor. IN: RSI = command arguments string (breaked) RCX = num. of words in the string, RAX = ptr to file in memory (STO), RBX = size (STO)
					; 				      OUT: RAX = ptr to file in memory	(LIM), RBX = size (LIM), set carry
;input
sys_input_key_check		dq 0	; 009 - Scans keyboard for input, but doesn't wait. OUT: AL = ASCII code or 0 if no key pressed
sys_input_key_wait		dq 0	; 010 - Waits for keypress and returns key. OUT: AL = key pressed
sys_input_string		dq 0	; 011 - Take string from keyboard entry. IN: RDI = location where string will be stored. RCX = max chars to accept
sys_input_string_with_cursor	dq 0	; 012 - Edit a stored string and show the cursor. IN: RDI = location where string will be stored, RCX = number of characters to accept. OUT: RCX = length of string that was inputed (NULL not counted)
;memory
sys_mem_allocate		dq 0	; 013 - Allocates the requested number of 2 MiB pages. IN: RCX = Number of pages to allocate. OUT: RAX = Starting address, RCX = Number of pages allocated (Set to the value asked for or 0 on failure)
sys_mem_release			dq 0	; 014 - Frees the requested number of 2 MiB pages. IN: RAX = Starting address, RCX = Number of pages to free. OUT: RCX = Number of pages freed
sys_mem_get_free		dq 0	; 015 - Returns the number of 2 MiB pages that are available. OUT: RCX = Number of free 2 MiB pages
;misc
sys_get_rdtsc			dq 0	; 016 - Get the time counter stamp of cpu. OUT: RAX = Number of ticks since reset
sys_get_timer			dq 0	; 017 - Get the current timer counter value. OUT: RAX = Time in 100th of a second since timer started
sys_get_timecounter		dq 0	; 018 - Get the current RTC clock counter value. OUT: RAX = Time in eights of a second since clock started
sys_delay			dq 0	; 019 - Delay by X eights of a second. IN: RAX = Time in eights of a second
sys_get_random			dq 0    ; 020 - Return a random integer OUT: RAX = Random number
sys_get_random_integer		dq 0    ; 021 - Return a random integer between Low and High (incl) IN: RAX = Low integer RBX = High integer. OUT: RCX = Random integer
sys_get_argc			dq 0	; 022 - Return the number arguments passed to the program (RUN string) OUT: AL = Number of arguments
sys_get_argv			dq 0	; 023 - Get the value of an argument that was passed to the program. IN: AL = Argument number. OUT: RSI = Start of numbered argument string
sys_get_strv			dq 0	; 024 - Get the value from a string to parse ; IN: AL  = Value number AH  = Delimiter RSI = String. OUT: RSI = Start of numbered value string
;screen
sys_move_cursor			dq 0	; 025 - Move the cursor on screen. IN: AL = row, AH = column
sys_inc_cursor			dq 0	; 026 - Increment the hardware cursor by one
sys_dec_cursor			dq 0	; 027 - Decrement the hardware cursor by one
sys_inc_ycursor 		dq 0	; 028 - Increment the hardware cursor by one in Y direction
sys_print_newline		dq 0	; 029 - Print a new line
sys_print_string		dq 0	; 030 - Displays text. IN: RSI = message location (zero-terminated string)
sys_print_string_with_color	dq 0	; 031 - Displays text in colour. IN: RSI = message location (zero-terminated string), RBX = colour
sys_print_char			dq 0	; 032 - Displays a char. IN: AL = char to display
sys_print_char_with_color	dq 0	; 033 - Displays a char in colour. IN: AL = char to display, RBX = colour
sys_print_extrachar		dq 0	; 034 - Displays a extrachar (graph mode only). IN: AX = extrachar to display, RBX = direction of printing ( 0=orizontal, 1=vertical, otherwise=fixed )
sys_print_chars			dq 0	; 035 - Displays text. IN: RSI = message location (A string, not zero-terminated), RCX = number of chars to print
sys_print_chars_with_color	dq 0	; 036 - Displays text with color. IN: RSI = message location (A string, not zero-terminated), RBX = color, RCX = number of chars to print
sys_print_char_hex		dq 0	; 037 - Displays a char in hex mode. IN: AL = char to display
sys_print_char_hex_with_color	dq 0	; 038 - Displays a char in hex mode with color. IN: AL = char to display, RBX = colour
sys_print_box_with_color	dq 0	; 039 - Print a box with a char. IN : RBX = color, AL = Y, AH = X, CL = X size, CH = Y size, DL = char
sys_screen_clear		dq 0	; 040 - Clear the screen
sys_screen_clear_from_cursor	dq 0	; 041 - Clear the screen from cursor to end
sys_row_clear			dq 0	; 042 - Clear a row from a selected column. IN: AL  = row to clear AH = column to start
sys_hide_cursor			dq 0	; 043 - Turns off cursor in text mode
sys_show_cursor			dq 0	; 044 - Turns on cursor in text mode
;smp
sys_smp_reset			dq 0	; 045 - Resets a CPU/Core. IN: AL = CPU #
sys_smp_wakeup			dq 0	; 046 - Wake up a CPU Core. IN:	AL = CPU #
sys_smp_wakeup_all		dq 0	; 047 - Wake up all CPU Cores
sys_smp_get_id			dq 0	; 048 - Returns the APIC ID of the CPU that ran this function. OUT: RAX = CPU's APIC ID number
sys_smp_enqueue			dq 0	; 049 - Add a workload to the processing queue. IN: RAX = Code to execute, RBX = Variable/Data to work on
sys_smp_dequeue			dq 0	; 050 - Dequeue a workload from the processing queue. OUT: RAX = Code to execute, RBX = Variable/Data to work on
sys_smp_run			dq 0	; 051 - Call the function address in RAX. IN: RAX = Memory location of code to run
sys_smp_queuelen		dq 0	; 052 - Returns the number of items in the processing queue. OUT: RAX = number of items in processing queue
sys_smp_numcores		dq 0	; 053 - Returns the number of cores in this computer. OUT: RAX = number of cores in this computer
sys_smp_wait			dq 0	; 054 - Wait until all other CPU Cores are finished processing
sys_smp_lock			dq 0	; 055 - Lock a variable. IN: RAX = Memory address of variable
sys_smp_unlock			dq 0	; 056 - Unlock a variable. IN: RAX = Memory address of variable
;sound
sys_speaker_tone		dq 0	; 057 - Generate PC speaker tone (call sys_speaker_off after). IN: RAX = note frequency
sys_speaker_on			dq 0	; 058 - Turn on PC speaker
sys_speaker_off			dq 0	; 059 - Shut off the PC speaker
sys_speaker_beep		dq 0	; 060 - Play a standard beep noise
;string
sys_int_to_string		dq 0	; 061 - Convert an integer to a string. IN: RAX = interger. OUT: RDI = destination string
sys_string_to_int		dq 0	; 062 - Convert a string to an interger. IN: RSI = source string. OUT: RAX = interger
sys_int_to_hex_string		dq 0	; 063 - Convert an integer to a hex string. IN: RAX = Integer value. RDI = location to store string
sys_hex_string_to_int		dq 0	; 064 - Convert up to 8 hexascii to bin. IN: RSI = Location of hex asciiz string. OUT: RAX = binary value of hex string
sys_string_length		dq 0	; 065 - Return the length of a string. IN: RSI = string address. OUT: RCX = string length
sys_string_find_char		dq 0	; 066 - Find first location of character in a string. IN: RSI = string location, AL = character to find. OUT: RAX = location in string, or 0 if char not present
sys_string_change_char		dq 0	; 067 - Change all instances of a character in a string. IN: RSI = string location, AL = character to replace, BL = replacement character
sys_string_copy			dq 0	; 068 - Copy the contents of one string into another. IN: RSI = source, RDI = destination
sys_string_truncate		dq 0	; 069 - Chop string down to specified number of characters. IN: RSI = string location, RAX = number of characters
sys_string_join			dq 0	; 070 - Join two strings into a third string. IN: RAX = string one, RBX = string two, RDI = destination string
sys_string_append		dq 0	; 071 - Append a string to an existing string. IN: RSI = String to be appended, RDI = Destination string
sys_string_chomp		dq 0	; 072 - Strip leading and trailing spaces from a string. IN: RSI = string location
sys_string_strip		dq 0	; 073 - Removes specified character from a string. IN: RSI = string location, AL = character to remove
sys_string_compare		dq 0	; 074 - See if two strings match. IN: RSI = string one, RDI = string two. OUT: Carry flag set if same
sys_string_uppercase		dq 0	; 075 - Convert a string to all uppercase characters. IN: RSI = string address
sys_string_lowercase		dq 0	; 076 - Convert a string to all lowercase characters. IN: RSI = string address
sys_is_digit			dq 0	; 077 - Check if character is a digit. IN: AL = ASCII char. OUT: EQ flag set if numeric
sys_is_alpha			dq 0	; 078 - Check if character is a letter. IN: AL = ASCII char. OUT: EQ flag set if alpha
sys_is_uppercase		dq 0	; 079 - Check if character is a uppercase letter. IN: AL = ASCII char. OUT: EQ flag set if uppercase
sys_is_lowercase		dq 0	; 080 - Check if character is a lowercase letter. IN: AL = ASCII char. OUT: EQ flag set if lowercase
sys_is_ctrl_letter		dq 0	; 081 - Check if character is a ctrl+letter. IN: AL = ASCII char. OUT: EQ flag set if ctrl+letter
sys_string_parse		dq 0	; 082 - Parse a string into individual words. IN: RSI = Address of string. OUT: RCX = word count
sys_get_date_string		dq 0	; 083 - Get date. OUT: RSI point to date string
sys_get_time_string		dq 0	; 084 - Get time. OUT: RSI point to time string
sys_get_datetime_string		dq 0	; 085 - Get datetime stamp. OUT: RSI point to datetime string
sys_byte_to_8digit_string	dq 0	; 086 - Convert a byte to a 8 digit string.  IN: AL  binary byte, RDI point to 8digit string. OUT: RSI point to 8digit string
;graph
sys_g_rowcol_to_yx		dq 0	; 087 - Convert row/column in pixel coordinates. IN: AL = row, AH = column. OUT: RAX = y start RBX = x start
sys_g_yx_to_rowcol		dq 0	; 088 - Convert pixel coordinates in row/column. IN: RAX = y start, RBX = x start. OUT:	AL = row, AH = column
sys_g_set_bgfg			dq 0	; 089 - Set background-foreground colors. IN : RCX = color
sys_g_get_bgfg			dq 0	; 090 - Get background-foreground colors. IN : None. OUT: RCX = color
sys_g_get_fontinfo		dq 0	; 091 - Get font information. IN : RAX = requested info (1=font(address), 2=ysize, 3=xsize, 4=(x*y)size, 5=dispy, 6=dispx). OUT: RAX = info
sys_g_get_lfbregs		dq 0	; 092 - Get LFB info in R14 an R15 registers. IN : None. OUT: R14 = pointer to LFB, R15 = bytes per line
sys_g_get_yxresolution		dq 0	; 093 - Get screen resolution in pixel. IN : None. OUT:	RAX = y resolution. RBX = x resolution
sys_g_is_graph			dq 0	; 094 - Check if graph mode is on. IN : None. OUT: set carry (if carry is set = graph mode)
sys_g_pixel			dq 0	; 095 - Draw a pixel on screen. IN: ECX = color, RAX = y, RBX = x, R14 = pointer to LFB, R15 = bytes per line
sys_g_fillrect			dq 0	; 096 - Fill a rectangle. IN: ECX = color, RAX = y start, RBX = x start, RSI = y size, RDI = x size, R14 = pointer to LFB, R15 = bytes per line
sys_g_saverect			dq 0	; 097 - Save a rectangle area of screen in memory. IN: RCX = memory location, RAX = y start, RBX = x start, RSI = y size, RDI = x size, R14 = pointer to LFB, R15 = bytes per line
sys_g_restorerect		dq 0	; 098 - Copy a rectangle area from memory to screen. IN: RCX = memory location, RAX = y start, RBX = x start, RSI = y size, RDI = x size, R14 = pointer to LFB, R15 = bytes per line
sys_g_line			dq 0	; 099 - Draw a line using the Bresenham algorithm. IN: ECX = color, RAX = y1, RBX = x1, RSI = y2, RDI = x2
sys_g_print			dq 0	; 100 - Print a bitmap char using a bytes mask. IN: RCX = color	(Background argb - Foreground argb), RAX = y start, RBX = x start, RSI = y size
					;	RDI = x size, R8 = address of bytes mask, R14 = pointer to LFB, R15 = bytes per line
sys_g_bitmap			dq 0	; 101 - Paint a bitmap image (with + or - zoom). IN: RCX = address of image, RAX = y start, RBX = x start, RSI = y size, RDI = x size,
					;	R12 = zoom (0 = no zoom), R14 = pointer to LFB, R15 = bytes per line
sys_g_screen_to_bitmap		dq 0	; 102 - Save a rectangle area of screen in memory with bitmap format. IN: RCX = memory location, RAX = y start, RBX = x start, RSI = y size,
					;	RDI = x size, R14 = pointer to LFB, R15 = bytes per line
;controls
sys_init_UI			dq 0	; 103 - Initialize User Interface manager with tiles and controls. IN : RAX = tiles_list, RBX = tile_a_pages
sys_exit_UI			dq 0	; 104 - Exit from User Interface manager
sys_tilectrl_set_focus_colors	dq 0	; 105 - Set the colors of on/off focus. IN : RAX = color of focus on, RBX = color of focus off
sys_tile_draw_message		dq 0	; 106 - Draw the message of tile. IN : RAX = pointer to tile struct
sys_tile_draw			dq 0	; 107 - Draw the tile (and the controls). IN : RAX = pointer to tile struct
sys_ctrl_draw			dq 0	; 108 - Draw the control. IN : RAX = pointer to control struct

;---------------------------------------


init_syscalls_table:

	mov rsi, qword[0x0000000000005024]
	mov rdi, sys_tab
	mov rcx, 108
.next:
	mov rax, qword[rsi]
	mov qword[rdi], rax

	add rsi, 8
	add rdi, 8
	dec rcx

	cmp rcx, 0
	jne .next

	ret


; =============================================================================
; EOF
